---

 source/interpret.c |  244 +++++++++++++++++++++++++++++------------------------
 source/interpret.h |    2 
 2 files changed, 139 insertions(+), 107 deletions(-)

diff --quilt old/source/interpret.c new/source/interpret.c
--- old/source/interpret.c
+++ new/source/interpret.c
@@ -338,7 +338,7 @@ int AddOp(int op, char **msg)
 	*msg = "macro too large";
 	return 0;
     }
-    ProgP->func = OpFns[op];
+    ProgP->op = op;
     ProgP++;
     return 1;
 }
@@ -639,7 +639,15 @@ int ContinueMacro(RestartData *continuat
     	
     	/* Execute an instruction */
     	inst = PC++;
-	status = (inst->func)();
+        switch (inst->op) {
+#define OP(name, fn) case OP_##name:
+#include "ops.h"
+#undef OP
+            status = (OpFns[inst->op])();
+            break;
+        default:
+            status = execError("Illegal instruction at %p", (char *)inst);
+        }
     	
     	/* If error return was not STAT_OK, return to caller */
     	if (status != STAT_OK) {
@@ -714,7 +722,7 @@ void PreemptMacro(void)
 */
 void ModifyReturnedValue(RestartData *context, DataValue dv)
 {
-    if ((context->pc-1)->func == fetchRetVal)
+    if ((context->pc-1)->op == OP_FETCH_RET_VAL)
 	*(context->stackP-1) = dv;
 }
 
@@ -2598,7 +2606,7 @@ static int callSubroutineFromSymbol(Symb
 	if (!sym->value.val.subr(FocusWindow, StackP,
 	    	nArgs, &result, &errMsg))
 	    return execError(errMsg, sym->name);
-    	if (PC->func == fetchRetVal) {
+    	if (PC->op == OP_FETCH_RET_VAL) {
             PUSH(result);
 	    PC++;
     	}
@@ -2664,7 +2672,7 @@ static int callSubroutineFromSymbol(Symb
     	sym->value.val.xtproc(FocusWindow->lastFocus,
     	    	(XEvent *)&key_event, argList, &numArgs);
         XtFree((char *)argList);
-    	if (PC->func == fetchRetVal) {
+    	if (PC->op == OP_FETCH_RET_VAL) {
             PUSH(noValue);
             PC++;
         }
@@ -2892,7 +2900,7 @@ static int returnValOrNone(int valOnStac
 	} else {
             PUSH(noValue);
 	}
-    } else if (PC->func == fetchRetVal) {
+    } else if (PC->op == OP_FETCH_RET_VAL) {
         if (valOnStack) {
             PUSH(retVal);
         } else {
@@ -3954,7 +3962,7 @@ static int typeOfOut(void)
     }
     retVal.val.str.len = strlen(retVal.val.str.rep);
 
-    if (PC->func == fetchRetVal) {
+    if (PC->op == OP_FETCH_RET_VAL) {
         PUSH(retVal);
         PC++;
     }
@@ -4361,46 +4369,57 @@ static void disasmInternal(Inst *inst, i
 #include "ops.h"
 #undef OP
     };
-    int i, j;
+    int i;
     static size_t opLen;
     
     if (!opLen) {
-        for (j = 0; j < N_OPS; ++j) {
-            if (opLen < strlen(opNames[j])) {
-                opLen = strlen(opNames[j]);
+        for (i = 0; i < N_OPS; ++i) {
+            if (opLen < strlen(opNames[i])) {
+                opLen = strlen(opNames[i]);
             }
         }
     }
 
     for (i = 0; i < nInstr; ++i) {
         printd("Prog %10p", &inst[i]);
-        for (j = 0; j < N_OPS; ++j) {
-            if (inst[i].func == OpFns[j]) {
-                printd(" %*s", (int)opLen, opNames[j]);
-                if (j == OP_PUSH_SYM || j == OP_ASSIGN) {
-                    Symbol *sym = inst[i+1].sym;
-                    printd(" %s", sym->name);
-                    if (sym->type == CONST_SYM
-                            && sym->value.tag == STRING_TAG) {
-                        dumpVal(sym->value);
-                    }
-                    ++i;
-                }
-                else if (j == OP_PUSH_IMMED) {
-                    printd(" <immediate %d>", inst[i+1].value);
-                    ++i;
-                }
-                else if (j == OP_BRANCH || j == OP_BRANCH_FALSE ||
-                        j == OP_BRANCH_NEVER || j == OP_BRANCH_TRUE) {
-                    printd(" to=(%+d) %p", inst[i+1].value,
-                            &inst[i+1] + inst[i+1].value);
-                    ++i;
-                }
-                else if (j == OP_CONCAT) {
-                    printd(" nExpr=%d", inst[i+1].value);
-                    ++i;
+
+        switch (inst[i].op) {
+#define OP(name, fn) case OP_##name:
+#include "ops.h"
+#undef OP
+            printd(" %*s", (int)opLen, opNames[inst[i].op]);
+
+            switch (inst[i].op) {
+            case OP_PUSH_SYM:
+            case OP_ASSIGN:
+                printd(" %s", inst[i+1].sym->name);
+                if (inst[i+1].sym->type == CONST_SYM
+                        && inst[i+1].sym->value.tag == STRING_TAG) {
+                    dumpVal(inst[i+1].sym->value);
                 }
-                else if (j == OP_SUBR_CALL) {
+                ++i;
+                break;
+
+            case OP_PUSH_IMMED:
+                printd(" <immediate %d>", inst[i+1].value);
+                ++i;
+                break;
+
+            case OP_BRANCH:
+            case OP_BRANCH_TRUE:
+            case OP_BRANCH_FALSE:
+            case OP_BRANCH_NEVER:
+                printd(" to=(%+d) %p",
+                        inst[i+1].value, &inst[i+1] + inst[i+1].value);
+                ++i;
+                break;
+
+            case OP_CONCAT:
+                printd(" nExpr=%d", inst[i+1].value);
+                ++i;
+                break;
+
+            case OP_SUBR_CALL: {
                     int args = inst[i+2].value;
                     printd(" %s", inst[i+1].sym->name);
                     if (args < 0) {
@@ -4411,7 +4430,9 @@ static void disasmInternal(Inst *inst, i
                     }
                     i += 2;
                 }
-                else if (j == OP_SUBR_CALL_UNPACK_ARRAY) {
+                break;
+
+            case OP_SUBR_CALL_UNPACK_ARRAY: {
                     int args = inst[i+2].value;
                     printd(" %s", inst[i+1].sym->name);
                     if (args < 0) {
@@ -4422,81 +4443,92 @@ static void disasmInternal(Inst *inst, i
                     }
                     i += 2;
                 }
-                else if (j == OP_BEGIN_ARRAY_ITER ||
-                        j == OP_BEGIN_ARRAY_ITER_ARRAY) {
-                    printd(" %s in", inst[i+1].sym->name);
-                    ++i;
-                }
-                else if (j == OP_ARRAY_ITER) {
-                    if (!inst[i+1].value) {
-                        /* without val */
-                        printd(" %s = %s++ end-loop=(%+d) %p",
-                                inst[i+2].sym->name,
-                                inst[i+3].sym->name,
-                                inst[i+4].value,
-                                &inst[i+4] + inst[i+4].value);
-                        i += 4;
-                    }
-                    else {
-                        /* with val */
-                        printd(" %s=%s = %s++ end-loop=(%+d) %p",
-                                inst[i+2].sym->name,
-                                inst[i+3].sym->name,
-                                inst[i+4].sym->name,
-                                inst[i+5].value,
-                                &inst[i+5] + inst[i+5].value);
-                        i += 5;
-                    }
-                }
-                else if (j == OP_ARRAY_ITER_ARRAY) {
-                    if (!inst[i+1].value) {
-                        /* without val */
-                        printd(" %s[] = %s++ end-loop=(%+d) %p",
-                                inst[i+2].sym->name,
-                                inst[i+3].sym->name,
-                                inst[i+4].value,
-                                &inst[i+4] + inst[i+4].value);
-                        i += 4;
-                    }
-                    else {
-                        /* with val */
-                        printd(" %s[]=%s = %s++ end-loop=(%+d) %p",
-                                inst[i+2].sym->name,
-                                inst[i+3].sym->name,
-                                inst[i+4].sym->name,
-                                inst[i+5].value,
-                                &inst[i+5] + inst[i+5].value);
-                        i += 5;
-                    }
+                break;
+
+            case OP_BEGIN_ARRAY_ITER:
+            case OP_BEGIN_ARRAY_ITER_ARRAY:
+                printd(" %s in", inst[i+1].sym->name);
+                ++i;
+                break;
+
+            case OP_ARRAY_ITER:
+                if (!inst[i+1].value) {
+                    /* without val */
+                    printd(" %s = %s++ end-loop=(%+d) %p",
+                            inst[i+2].sym->name,
+                            inst[i+3].sym->name,
+                            inst[i+4].value,
+                            &inst[i+4] + inst[i+4].value);
+                    i += 4;
                 }
-                else if (j == OP_ARRAY_REF ||
-                         j == OP_ARRAY_DELETE ||
-                         j == OP_ARRAY_ASSIGN ||
-                         j == OP_ANONARRAY_INDEX_VAL ||
-                         j == OP_NAMED_ARG1 ||
-                         j == OP_NAMED_ARGN) {
-                    printd(" nDim=%d", inst[i+1].value);
-                    ++i;
+                else {
+                    /* with val */
+                    printd(" %s=%s = %s++ end-loop=(%+d) %p",
+                            inst[i+2].sym->name,
+                            inst[i+3].sym->name,
+                            inst[i+4].sym->name,
+                            inst[i+5].value,
+                            &inst[i+5] + inst[i+5].value);
+                    i += 5;
                 }
-                else if (j == OP_ARRAY_REF_ASSIGN_SETUP) {
-                    printd(" binOp=%s nDim=%d",
-                            inst[i+1].value ? "true" : "false",
-                            inst[i+2].value);
-                    i += 2;
+                break;
+
+            case OP_ARRAY_ITER_ARRAY:
+                if (!inst[i+1].value) {
+                    /* without val */
+                    printd(" %s[] = %s++ end-loop=(%+d) %p",
+                            inst[i+2].sym->name,
+                            inst[i+3].sym->name,
+                            inst[i+4].value,
+                            &inst[i+4] + inst[i+4].value);
+                    i += 4;
                 }
-                else if (j == OP_PUSH_ARRAY_SYM) {
-                    printd(" %s %s",
-                            inst[i+1].sym->name,
-                            inst[i+2].value ? "createAndRef" : "refOnly");
-                    i += 2;
+                else {
+                    /* with val */
+                    printd(" %s[]=%s = %s++ end-loop=(%+d) %p",
+                            inst[i+2].sym->name,
+                            inst[i+3].sym->name,
+                            inst[i+4].sym->name,
+                            inst[i+5].value,
+                            &inst[i+5] + inst[i+5].value);
+                    i += 5;
                 }
+                break;
+
+            case OP_ARRAY_REF:
+            case OP_ARRAY_DELETE:
+            case OP_ARRAY_ASSIGN:
+            case OP_ANONARRAY_INDEX_VAL:
+            case OP_NAMED_ARG1:
+            case OP_NAMED_ARGN:
+                printd(" nDim=%d", inst[i+1].value);
+                ++i;
+                break;
+
+            case OP_ARRAY_REF_ASSIGN_SETUP:
+                printd(" binOp=%s nDim=%d",
+                        inst[i+1].value ? "true" : "false",
+                        inst[i+2].value);
+                i += 2;
+                break;
+
+            case OP_PUSH_ARRAY_SYM:
+                printd(" %s %s",
+                        inst[i+1].sym->name,
+                        inst[i+2].value ? "createAndRef" : "refOnly");
+                i += 2;
+                break;
 
-                printd("\n");
+            default:
                 break;
             }
-        }
-        if (j == N_OPS) {
-            printd(" %x\n", inst[i].value);
+
+            printd("\n");
+            break;
+
+        default:
+            printd(" <unknown op %d>\n", inst[i].op);
+            break;
         }
     }
 }
diff --quilt old/source/interpret.h new/source/interpret.h
--- old/source/interpret.h
+++ new/source/interpret.h
@@ -62,7 +62,7 @@ struct ProgramTag;
 struct SymbolRec;
 
 typedef union InstTag {
-    int (*func)(void);
+    enum operations op;
     int value;
     struct SymbolRec *sym;
 } Inst;
